// JavaScript Document
// ship script event handler triggered when a new AI is loaded
"use strict";

this.name = "Draco Pirate Group AI";
this.aiStarted = function() {
    // create a new AI controller and assign it this ship
	var ai = new worldScripts["oolite-libPriorityAI"].PriorityAIController(this.ship);
	ai.setParameter("oolite_flag_escortsCoverRetreat",true);
    if (worldScripts["oolite-libPriorityAI"]._getCommunicationPersonalities("pirate-freighter").length > 0)
	{
		ai.setCommunicationsRole("pirate-freighter");
	}
	else
	{
		ai.setCommunicationsRole("pirate");
	}
    ai.setParameter("oolite_friendlyRoles",["oolite-pirate"]);
	// set up the priority list
	var priorities = [ 
	{
		condition: ai.conditionLosingCombat,
		behaviour: ai.behaviourFleeCombat,
		reconsider: 5
	},
	{
		condition: ai.conditionInCombat,
		configuration: ai.configurationAcquireCombatTarget,
		behaviour: ai.behaviourDestroyCurrentTarget,
		reconsider: 5
	},
    {	
    	condition: ai.conditionGroupHasEnoughLoot,
		behaviour: ai.templateReturnToBaseOrPlanet()
		
	},
	{	
    	condition: ai.conditionGroupAttritionReached,
		behaviour: ai.templateReturnToBaseOrPlanet()
		
	},
	{
		condition: ai.conditionHasRememberedTarget,
		truebranch: [
       
	{
		preconfiguration: ai.configurationCheckScanner,
        condition: ai.conditionScannerContainsSalvageForMe,
		configuration: ai.configurationAcquireScannedTarget,
		behaviour: ai.behaviourCollectSalvage,
		reconsider: 25
	},
    {
		preconfiguration: ai.configurationCheckScanner,
        condition: ai.conditionScannerContainsHunters,
        	truebranch: [
     { 	
		behaviour: ai.behaviourFollowCurrentTarget,
		reconsider: 125
	}
    ],
    falsebranch:
    [
	{
		behaviour: ai.behaviourRobTarget,
		reconsider: 5
	}
	],
	},
    ],
	falsebranch: 
    [
	{
		condition: ai.conditionPlayerNearby,
		configuration: ai.configurationAcquirePlayerAsTarget,
		behaviour: ai.behaviourFollowCurrentTarget,
		reconsider: 125
	},
	{
		preconfiguration: ai.configurationCheckScanner,
        condition: ai.conditionScannerContainsPirateVictims,
        configuration: ai.configurationAcquireScannedTarget,
		behaviour: ai.behaviourFollowCurrentTarget,
		reconsider: 125
	}
	],
	},
	{	
    	notcondition: ai.conditionGroupHasEnoughLoot,
		configuration: ai.configurationSetDestinationToWitchpoint,
		behaviour: ai.behaviourApproachDestination,
		reconsider: 20
	}
	
	];
	// apply the priority list to the AI
    ai.setPriorities(priorities);
}
